/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro
 Maria del Carmen Sánchez Medrano

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.exporter.framework.fmiInterface;

import java.util.HashMap;
import java.util.Map;

public class VariableHandler {
    private final Map<String, Variable> variables;

    public VariableHandler() {
        this.variables = new HashMap<>();
    }

    public Variable get(String variableName) {
        return variables.get(variableName);
    }

    public void register(String variableName, Variable variable) {
        variables.put(variableName, variable);
    }

    public void set(String variableName, Object value) {
        variables.get(variableName).setValue(value);
    }
}
