/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro
 Maria del Carmen Sánchez Medrano

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI org.javafmi.fmubuilder.Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.exporter.fmubuilder;

import org.simpleframework.xml.core.Persister;
import org.simpleframework.xml.strategy.Type;
import org.simpleframework.xml.strategy.Visitor;
import org.simpleframework.xml.strategy.VisitorStrategy;
import org.simpleframework.xml.stream.InputNode;
import org.simpleframework.xml.stream.NodeMap;
import org.simpleframework.xml.stream.OutputNode;

import java.io.File;

public class ModelDescriptionSerializer {


    public static File serialize(Object modelDescriptionClass, File outFile) {
        try {
            new Persister(new VisitorStrategy(new ModelDescriptionVisitor())).write(modelDescriptionClass, outFile);
            return outFile;
        } catch(Exception e) {
            e.printStackTrace();
        }
        throw new RuntimeException("Impossible to serialize class " + modelDescriptionClass.toString());

    }

    private static class ModelDescriptionVisitor implements Visitor {
        @Override
        public void read(Type type, NodeMap<InputNode> node) throws Exception {
        }

        @Override
        public void write(Type type, NodeMap<OutputNode> node) throws Exception {
            node.remove("class");
        }
    }
}
