/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro
 Maria del Carmen Sánchez Medrano

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.exporter.fmubuilder;

import org.javafmi.fmubuilder.Library;

import java.io.InputStream;

public class ShellFmu implements Library {
    public static final String DARWIN_64 = "libdarwin64Shell.dylib";
    public static final String WIN_32 = "libwin32Shell.dll";
    public static final String WIN_64 = "libwin64Shell.dll";
    public static final String LINUX_64 = "liblinux64Shell.so";
    private String shellFmuName;

    public ShellFmu(String shellFmuName) {
        this.shellFmuName = shellFmuName;
    }

    @Override
    public InputStream getInputStream() {
        return getClass().getClassLoader().getResourceAsStream(shellFmuName);
    }

    @Override
    public String getName() {
        return shellFmuName;
    }
}
