#!/bin/bash
rm *.o
rm AllTests*

sources=$(find ./src -name *.cpp)
tests=$(find ./test -name *.cpp)
cutestSources="./lib/cutest/CuTest.c"

echo "########################## Compiling ##########################"

i686-w64-mingw32-g++ -g -fno-exceptions -fno-rtti \
	-Isrc/avian/win32/include -Isrc/fmi \
	-D_JNI_IMPLEMENTATION_ -D__WIN32 \
  -c ${sources} ${tests} ${cutestSources}

echo "########################## Linking ##########################"
i686-w64-mingw32-g++ -static-libstdc++ -static-libgcc \
	*.o src/avian/win32Objects/*.o \
	-Lsrc/avian/win32/lib -lmingwthrd -lm -lz -lws2_32 \
  -lIphlpapi -mwindows -mconsole -o AllTests.exe

echo "########################## Running ##########################"
time ./AllTests