#ifndef FMI_FUNCTION_TYPES
#define FMI_FUNCTION_TYPES
#include "fmiTypesPlatform.h"
#include <stdio.h>

typedef enum {
	fmiOK,
	fmiWarning,
	fmiDiscard,
	fmiError,
	fmiFatal,
	fmiPending} fmiStatus;

typedef enum { 
	fmiModelExchange,
	fmiCoSimulation
} fmiType;

typedef enum {
    fmiDoStepStatus,
    fmiPendingStatus,
    fmiLastSuccessfulTime,
    fmiTerminated
} fmiStatusKind;

typedef struct {
	void (*logger) (fmiComponentEnvironment componentEnviroment, fmiString instanceName, fmiStatus status, fmiString category, fmiString message, ...);
	//void (*allocateMemory) (size_t numberOfObjects, size_t size);
	void* (*allocateMemory) (size_t numberOfObjects, size_t size);
	void (*freeMemory) (void* obj);
	void (*stepFinished) (fmiComponentEnvironment componentEnvironment, fmiStatus status);
	fmiComponentEnvironment componentEnvironment;
} fmiCallbackFunctions;

#endif