#ifndef FMI_FUNCTIONS
#define FMI_FUNCTIONS

#include <stdlib.h>
#include "fmiTypesPlatform.h"
#include "fmiFunctionTypes.h"

extern "C" void __cxa_pure_virtual(void){ abort();}

#ifdef __cplusplus
extern "C"{
#endif

#if (defined __WIN32) || (defined __CYGWIN__) || (defined __MSYS__)
	#define EXPORT __declspec(dllexport)
#else
	#define EXPORT __attribute__((visibility("default"))) __attribute__((used))
#endif

EXPORT const char* fmiGetTypesPlatform();
EXPORT const char* fmiGetVersion();
EXPORT fmiStatus fmiSetDebugLogging(fmiComponent component, fmiBoolean loggingOn, size_t numberOfCategories, const fmiString categories[]);
EXPORT fmiComponent fmiInstantiate(fmiString instanceName, fmiType fmuType, fmiString fmuGUID, fmiString fmuResourceLocation, const fmiCallbackFunctions* callbacksFunctions, fmiBoolean visible, fmiBoolean loggingOn);
EXPORT fmiStatus fmiSetupExperiment(fmiComponent component, fmiBoolean toleranceDefined, fmiReal tolerance, fmiReal startTime, fmiBoolean stopTimeDefined, fmiReal stopTime);
EXPORT fmiStatus fmiEnterInitializationMode(fmiComponent component);
EXPORT fmiStatus fmiExitInitializationMode(fmiComponent component );
EXPORT fmiStatus fmiTerminate(fmiComponent component);
EXPORT fmiStatus fmiFreeInstance(fmiComponent component);
EXPORT fmiStatus fmiReset(fmiComponent component);
EXPORT fmiStatus fmiGetReal(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, fmiReal values[]);
EXPORT fmiStatus fmiGetInteger(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, fmiInteger values[]);
EXPORT fmiStatus fmiGetBoolean(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, fmiBoolean values[]);
EXPORT fmiStatus fmiGetString(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, fmiString values[]);
EXPORT fmiStatus fmiSetReal(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, const fmiReal values[]);
EXPORT fmiStatus fmiSetInteger(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, const fmiInteger values[]);
EXPORT fmiStatus fmiSetBoolean(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, const fmiBoolean values[]);
EXPORT fmiStatus fmiSetString(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, const fmiString values[]);
EXPORT fmiStatus fmiGetFMUstate(fmiComponent component, fmiFMUstate* state);
EXPORT fmiStatus fmiSetFMUstate(fmiComponent component, fmiFMUstate state);
EXPORT fmiStatus fmiFreeFMUstate(fmiComponent component, fmiFMUstate* state);
EXPORT fmiStatus fmiSerializedFMUstateSize(fmiComponent component, fmiFMUstate, size_t* stateSize);
EXPORT fmiStatus fmiSerializeFMUstate(fmiComponent component, fmiFMUstate state, fmiByte serializedState[], size_t serializedStateSize);
EXPORT fmiStatus fmiDeSerializeFMUstate(fmiComponent component, const fmiByte serializedState[], size_t serializedStateSize, fmiFMUstate* state);
EXPORT fmiStatus fmiGetDirectionalDerivative(fmiComponent component, const fmiValueReference unknownReference[], size_t numberOfUnknowns, const fmiValueReference knownReferences[], size_t numberOfKnowns, const fmiReal dvKnown[], fmiReal dvUnKnown[]);
EXPORT fmiStatus fmiSetRealInputDerivatives(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, const fmiInteger order[], const fmiReal values[]);
EXPORT fmiStatus fmiGetRealOutputDerivatives(fmiComponent component, const fmiValueReference valueReference[], size_t numberOfValues, const fmiInteger order[], fmiReal values[]);
EXPORT fmiStatus fmiDoStep(fmiComponent component, fmiReal currentComunicationTime, fmiReal stepSize, fmiBoolean noSetFmuFmuStatePriorToCurrentPoint);
EXPORT fmiStatus fmiCancelStep(fmiComponent component);
EXPORT fmiStatus fmiGetStatus(fmiComponent component, const fmiStatusKind kind, fmiStatus* status);
EXPORT fmiStatus fmiGetRealStatus(fmiComponent component, const fmiStatusKind kind, fmiReal* value);
EXPORT fmiStatus fmiGetIntegerStatus(fmiComponent component, const fmiStatusKind kind, fmiInteger* value);
EXPORT fmiStatus fmiGetBooleanStatus(fmiComponent component, const fmiStatusKind kind, fmiBoolean* value);
EXPORT fmiStatus fmiGetStringStatus(fmiComponent component, const fmiStatusKind kind, fmiString* value);

#ifdef __cplusplus
}
#endif
#endif