#ifndef VIRTUAL_MACHINE_H
#define VIRTUAL_MACHINE_H
#include "jni.h"

extern const void* VirtualMachine;

void* createVirtualMachine(char* bootstrap, char* bootClasspath);
void destroyVirtualMachine(void* _self);
int resetVirtualMachine(void* _self);
int invokeTerminate(void* _self);
int loadMainObject(void* _self, const char* objectClassName);

int invokeSetupExperiment(void* _self, int toleranceDefined, double tolerance, double startTime, int stopTimeDefined, double stopTime);
int invokeEnterInitializationMode(void* _self);
int invokeExitInitializationMode(void* _self);

void invokeGetReal(void* _self, int valueReferences[], int numberOfValues, double values[]);
void invokeGetInteger(void* _self, int valueReferences[], int numberOfValues, int values[]);
void invokeGetBoolean(void* _self, int valueReferences[], int numberOfValues, int values[]);
void invokeGetString(void* _self, int valueReferences[], int numberOfValues, char* values[]);

int invokeSetReal(void* _self, int valueReferences[], int numberOfValues, double values[]);
int invokeSetInteger(void* _self, int valueReferences[], int numberOfValues, int values[]);
int invokeSetBoolean(void* _self, int valueReferences[], int numberOfValues, int values[]);
int invokeSetString(void* _self, int valueReferences[], int numberOfValues, char* values[]);

int invokeDoStep(void* _self, double currentComunicationTime, double stepSize, int noSetFmuFmuStatePriorToCurrentPoint);
int invokeCancelStep(void* _self);

void invokeGetDirectionalDerivative(void* _self, int unknownReference[], int numberOfUnknowns, int knownReferences[], int numberOfKnowns, double dvKnown[], double dvUnKnown[]);
void invokeGetRealOutputDerivatives(void* _self, int valueReference[], int numberOfValues, int order[], double values[]);
int invokeSetRealInputDerivatives(void* _self, int valueReferences[], int numberOfValues, int order[], double values[]);

#endif