#include "fmi/fmiFunctions.h"
#include <stdlib.h>
#include <dlfcn.h>


typedef int (*instantiateFunction)(fmiString instanceName, fmiType fmuType, fmiString fmuGUID, fmiString fmuResourceLocation,  const fmiCallbackFunctions* functions,fmiBoolean visible, fmiBoolean loggingOn);

int main(int argc, const char* argv[]){
	void* libHandle = dlopen("libdarwin64.dylib", RTLD_LAZY);
	if(libHandle == 0) {
		printf("ERROR loading library\n");
		exit(1);
	}
	instantiateFunction instantiate = (instantiateFunction) dlsym(libHandle, "fmiInstantiate");
	if(instantiate <= 0) {
		printf("ERROR getting instantiate\n");
		exit(1);
	}
	instantiate("hello", fmiCoSimulation, "guid", "", 0, fmiFalse, fmiFalse);
	dlclose(libHandle);
}