#include <stdlib.h>
#include "../lib/cutest/CuTest.h"
#include "../src/jvm/VirtualMachine.h"

void loads_and_destroys_the_virtual_machine(CuTest* cutest){
	const char* bootstrap = "-Davian.bootstrap=AllTests.exe";
	const char* bootClasspath = "-Xbootclasspath:rt.jar;Counter.jar";
	void* virtualMachine = createVirtualMachine((char*) bootstrap, (char*) bootClasspath);
	const char* className = "Counter";
	loadMainObject(virtualMachine, className);
	CuAssertPtrNotNull(cutest, virtualMachine);
	destroyVirtualMachine(virtualMachine);
}

CuSuite* loadFmiInterfaceSuite(){
	CuSuite* suite = CuSuiteNew();
	SUITE_ADD_TEST(suite, loads_and_destroys_the_virtual_machine);
	return suite;
}