#include <stdio.h>
#include "../lib/cutest/CuTest.h"


CuSuite* loadPathUtilitiesSuite();
CuSuite* loadFmiInterfaceSuite();

CuSuite* loadAllSuites(){
	CuSuite* allSuites = CuSuiteNew();
	CuSuiteAddSuite(allSuites, loadPathUtilitiesSuite());
	CuSuiteAddSuite(allSuites, loadFmiInterfaceSuite());
	return allSuites;
}

void displayResult(char* result){
	printf("%s\n", result);
}

char* runAllTests(CuSuite* allSuites){
	CuString* output = CuStringNew();
	CuSuiteRun(allSuites);
	CuSuiteSummary(allSuites, output);
	CuSuiteDetails(allSuites, output);
	return output->buffer;
}

int main(int argc, char const *argv[]){
	displayResult(runAllTests(loadAllSuites()));
}