/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro
 Maria del Carmen Sánchez Medrano

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */

import org.javafmi.modeldescription.v2.IntegerVariable;
import org.javafmi.modeldescription.v2.ModelDescription;
import org.javafmi.modeldescription.v2.RealVariable;

public class FmiModelDescription extends ModelDescription {
    public static final String CAR_SPEED = "car.speed";
    public static final String ODOMETER_DISTANCE = "odometer.distance";

    public FmiModelDescription(String modelName) {
        super(modelName);
        addVariable(new IntegerVariable(CAR_SPEED));
        addVariable(new RealVariable(ODOMETER_DISTANCE));
    }
}
